#ifndef UTILITY_H_INCLUDED
#define UTILITY_H_INCLUDED

#ifdef WIN32
    #define fseek fseeko64
    #define ftell ftello64
    #define fopen fopen64
#endif

void logPrintf(const c8 * format, ...);
void * myalloc(size_t size);
void myfree(void * ptr);

inline __attribute__((__malloc__)) void * operator new(size_t size) {
	return myalloc(size);
}

inline __attribute__((__malloc__)) void * operator new [] (size_t size) {
	return myalloc(size);
}

inline void operator delete(void * ptr) {
	return myfree(ptr);
}

inline void operator delete [] (void *ptr) {
	return myfree(ptr);
}

inline u64 getFileLength(FILE * f) {
    fseek(f, 0, SEEK_END);
    u64 len = ftell(f);
    fseek(f, 0, SEEK_SET);
    return len;
}

void clearScreen();
s32 mymkdir(const string &dirname);

#define foreach(type, variable) for(type it = (variable).begin(); it != (variable).end(); it++)
#define foreach2(type, variable) for(type it2 = (variable).begin(); it2 != (variable).end(); it2++)

#define E_INDEX_2D(x, y, width, bpp, rgb, elements) (elements)[(y) * ((width) * (bpp)) + ((x) * (bpp)) + (rgb)]

#define DEVIDE_ROUND_DOWN(a, b) ((a - (a % b)) / b)

#define PACKED __attribute__((__packed__))

#define lerp(a, b, amount) (a * (1.0f - amount) + b * amount)


#endif // UTILITY_H_INCLUDED
